-- Yet another simple class

yasc = {}
yasc.title = "Classes"
yasc.next = "Next Page"
yasc.prev = "Previous Page"
yasc.killmsg = "class change"
yasc.action = 3 -- F4
yasc.classes = {}
yasc.pages = {}
yasc.players = {}

addhook("serveraction", "yasc.serveraction")
addhook("menu", "yasc.menu")
addhook("spawn", "yasc.spawn")
addhook("join", "yasc.join")

yasc.add = function(name, spawn)	-- name, spawn function
	table.insert(yasc.classes, {name, spawn})
end

yasc.serveraction = function(id, action)
	if action == yasc.action then
		yasc.openmenu(id, 0)
	end
end

yasc.openmenu = function(id, page)
	local cur = page*7+1	-- cursor for the table
	local str = yasc.title	-- string for building the menu
	
	for i = cur, cur+6 do
		if not yasc.classes[i] then
			str = str .. ","	-- empty
		else
			str = str .. "," .. yasc.classes[i][1]	-- add class to menu
		end
	end
	
	if cur > 1 then str = str .. "," .. yasc.prev	-- prev button
	else str = str .. ",(" .. yasc.prev .. ")" end
	
	if yasc.classes[cur+7] then str = str .. "," .. yasc.next	-- next button
	else str = str .. ",(" .. yasc.next .. ")" end
	
	menu(id, str)
	yasc.pages[id] = page	-- store the page
end

yasc.menu = function(id, title, button)
	if title ~= yasc.title then return end
	
	local page = yasc.pages[id]
	
	if button == 8 then yasc.openmenu(id, page-1)		-- prev
	elseif button == 9 then yasc.openmenu(id, page+1)	-- next
	else
		local class = page*7 + button	-- find class id
		yasc.players[id] = class		-- set class
		msg2(id, "You are now " .. yasc.classes[class][1] .. "!")	-- just a stupid message
		parse("customkill 0 \"" .. yasc.killmsg .. "\" " .. id)		-- let's kill the player for some reason
	end
end

yasc.spawn = function(id)
	local class = yasc.players[id]
	if yasc.classes[class] then
		yasc.classes[class][2](id)	-- trigger spawn function
	end
end

yasc.join = function(id)
	yasc.players[id] = 1
	yasc.pages[id] = 0
end